# frozen_string_literal: true

require 'marauders_map/version'
require 'active_support/core_ext/module/attribute_accessors_per_thread'

module MaraudersMap
  extend self

  def reveal_routes!
    routes.each do |(_name, route)|
      app.routes.append(&route)
    end

    app.routes.finalize!
  end

  def draw(name, &routes)
    append_route(name, &routes)
  end

  private

  thread_mattr_accessor :statement, :routes

  def app
    Rails.application
  end

  def append_route(name, &definition)
    self.routes ||= {}
    routes[name] = definition
  end
end
